#include <bits/stdc++.h>
using namespace std;
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n,m;
    cin>>n>>m;
    int a[n][m];
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            cin>>a[i][j];
        }
    }
    int q;
    cin>>q;
    int x[q],y[q];
    for(int i=0;i<q;i++){
        cin>>x[i]>>y[i];
    }
    for(int i=0;i<q;i++){
        int p=0,d=0,br=0;
        while(p!=n-1 && d!=m-1){
            while(p<n-1){
                if(p==x[i]-1 && d==y[i]-1){
                    break;
                }
                br=br+a[p][d];
                p++;
            }
            while(d<m-1){
                if(p==x[i]-1 && d==y[i]-1){
                    break;
                }
                br=br+a[p][d];
                d++;
            }
            while(p<n-1){
                br=br+a[p][d];
                p++;
            }
        }
        br=br+a[n-1][m-1];
        cout<<br<<endl;
    }

 return 0;
}